#include <unistd.h>
#include <stdarg.h>

/* Generic */
#define SL(s) (s), (sizeof(s)-1)
#define BL(b) (b), (sizeof(b))
extern int jobid;

char *vmprintf(const char *fmt, va_list ap);
char *mprintf(const char *fmt, ...);

/* Logging */
void init_avlogbuf(void);
void avlogbuf_callback(void *classp, int level, const char *fmt, va_list ap);
char *get_avlogbuf(void);

/* API */
int ping_job(int id, char *state, char *status, ...);
void job_failed(char *msg, ...);

/* JSON parser */
#define JSTR_SIZE 100

ssize_t jbin(char *s, char *buf, size_t len);
char *jstrb(char *s, char *err, char *buf);
char *jstr(char *s, char *err);
int jint(char *s, int err);
char *jenter(char *s);
char *jnext(char *s);
char *jvalue(char *s);
char *jlookup(char *s, char *key);

/* JSON util */
char *jescape(char *s);
