#include <curl/curl.h>
#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

#include "../util.h"
#include "../config.h"

static size_t curl_write_cb(char *ptr, size_t size, size_t nmemb, void *user)
{
	return size*nmemb;
}

int ping_job(int id, char *state, char *status, ...)
{
	int ret;
	CURL *curl;
	va_list ap;
	char *p, *url, *e_host, *e_status, *e_apikey, *e_state;
	char hostbuf[HOST_NAME_MAX+1];
	if (!(curl = curl_easy_init()))
		return -1;
	curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, curl_write_cb);
	e_apikey = curl_easy_escape(curl, CONFIG_APIKEY, 0);
	e_state = curl_easy_escape(curl, state, 0);
	if (gethostname(BL(hostbuf)))
		strcpy(hostbuf, "localhost");
	e_host = curl_easy_escape(curl, hostbuf, 0);
	if (status)
	{
		va_start(ap, status);
		p = vmprintf(status, ap);
		va_end(ap);
	}
	else
		p = strdup("{}");
	e_status = curl_easy_escape(curl, p, 0);
	free(p);
	p = mprintf("apikey=%s&state=%s&host=%s&status=%s", e_apikey, e_state,
			e_host, e_status);
	curl_free(e_apikey);
	curl_free(e_state);
	curl_free(e_host);
	curl_free(e_status);
	curl_easy_setopt(curl, CURLOPT_POSTFIELDS, p);
	url = mprintf("%s/internal/jobs/api/job/%i/ping", CONFIG_APIBASE, id);
	curl_easy_setopt(curl, CURLOPT_URL, url);
	ret = curl_easy_perform(curl);
	free(p);
	free(url);
	curl_easy_cleanup(curl);
	if (ret)
	{
		fprintf(stderr, "API call to \"%s\" failed: %s\n", url, curl_easy_strerror(ret));
		return -1;
	}
	else
		return 0;
}
