#include <pthread.h>
#include <libavutil/log.h>

#include "../util.h"

static char *logbuffer;
static size_t logsize;
static FILE *logstream;

void init_avlogbuf(void)
{
	logbuffer = 0;
	logsize = 0;
	if (!(logstream = open_memstream(&logbuffer, &logsize)))
		exit(99);
	av_log_set_callback(avlogbuf_callback);
}

void avlogbuf_callback(void *class, int level, const char *fmt, va_list ap)
{
	int print_prefix;
	char buf[200];
	if (level >= AV_LOG_VERBOSE)
		return;
	print_prefix = 1;
	av_log_format_line(class, level, fmt, ap, BL(buf), &print_prefix);
	fputs(buf, logstream);
}

char *get_avlogbuf(void)
{
	char *p;
	if (!logstream)
		return "";
	fclose(logstream);
	p = logbuffer;
	init_avlogbuf();
	fputs(p, logstream);
	return p;
}
